//2021年01月08日 1.0.3版本
var MOD = "[WebInnerAD] JS ";
var IOS = 1;
var Android = 2;
var platform;
/**
 优化单页面存在多个规则时，第一个规则出错后，导致第二个规则无法正常加载
 */
function addDiv(os,dataArray) {
    platform = os;
  if(dataArray.length == 0){
    if (platform == Android) {
      return "error1";
    }
    return;
  }
  //移除已经填加的广告位
  for (let key in dataArray){
    let dic = dataArray[key];
    if( typeof(dic)=="object" ){
      let attribute =  dic['attribute'];
      let className =  attribute['class'];

      if(className.length > 0){
        let xPath = "//div[@class='" + className +"']"
        let nodes = getElementByXpath(xPath);
        if(nodes.length > 0){
          if (platform == Android) {
            console.log(MOD + " remove old div");
          }
          for(var i = 0;i< nodes.length ;i ++){
            nodes[i].remove();
          }
        }
      }
    }
  }
  var frameList = [];

  for (let key in dataArray){
    let dic = dataArray[key];
    if(typeof(dic) == "object"){
      let frame = getDivFrameWith(dic.parentRule,dic.attribute,dic.postion);
      if (frame != null){
        frameList.push(frame);
      }
    }
  }
  if (platform == Android) {
    if (frameList.length > 0){
      return frameList;
    }
    return "error";
  }else {
    if (frameList.length > 0){
      var jsonstr = JSON.stringify(frameList);
        window.webkit.messageHandlers.adParentViewFrame.postMessage({
        frames:frameList
      });
    }
  }
}

function getDivFrameWith(parent_xpath,attribute,postion) {
  /* x_path 获取 父元素 的Xpath
   postion 广告位置在父元素中的位置
   attribute 广告div 的属性
   */
  if (platform == Android) {
    console.log(MOD + "parent_xpath: " + parent_xpath + ",attribute:" +attribute + ",postion:" + postion);
  }
  let parent = getElementByXpath(parent_xpath)[0];
  if (typeof(parent) == "undefined"){
    return null;
  }
//  console.log(parent);
  let div = document.createElement("div");//添加 div
  for(let key in attribute){//设置 div属性

    div.setAttribute(key,attribute[key]);
  }

  if(postion == "top"){
    let fristEle =　parent.firstElementChild;
    parent.insertBefore(div,fristEle);
  }else if(postion == "bottom"){
    parent.appendChild(div);
  }
  var frame;
  if (platform == Android) {
    frame = {
      top:div.getBoundingClientRect().top,
      totalH:document.body.scrollHeight,
      topRatop: div.getBoundingClientRect().top/document.body.clientHeight
    };
  }else{
    var x = div.getBoundingClientRect().left+document.documentElement.scrollLeft;
    var y = div.getBoundingClientRect().top+document.documentElement.scrollTop;
    var w = div.offsetWidth;
    var h = div.offsetHeight;

    frame = {
      origin_x: x,
      origin_y:y,
      size_w:w,
      size_h:h
    };
  }
  return frame;
}


function getElementByXpath(STR_XPATH) {
  var xresult = document.evaluate(STR_XPATH, document, null, XPathResult.ANY_TYPE, null);
  var xnodes = [];
  var xres;
  while (xres = xresult.iterateNext()) {
    xnodes.push(xres);
  }
  return xnodes;
}